<template>
	<a-drawer
		:title="'预约码'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<div style="padding: 1px;border: 1px gray solid">
				<div id="qrCode" style="background-color: #0169B5FF;text-align: center">
					<div style="background-color: white;border-radius: 0 0 30% 30%;height: 200px;padding-top: 50px">
					<span style="font-size: 60px;color: #0169B5FF;">
						扫码填写入场申请
					</span>
					</div>
					<div style="padding-top: 50px">
						<div>
							<span>
								<img id="ossImg" :src="formData.qrCodePicUrl" allow-clear/>
							</span>
						</div>
						<br>
						<div style="font-size: 30px">
							<span style="padding: 10px 10px;color: white">
								粮库：{{ formData.depotGrainName }}
							</span>
						</div>
						<br>
					</div>
				</div>
			</div>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="exportPic" :loading="submitLoading">下载</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotGrainForm">
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import depotGrainApi from '@/api/biz/depotGrainApi'
import tool from "@/utils/tool";
import router from "@/router";
import sysConfig from "@/config";
import html2Canvas from 'html2Canvas'
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	}
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotGrainApi
				.depotGrainSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.catch((err) => {
					emit(err)
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
const exportPic = () => {
	html2Canvas(document.querySelector("#qrCode"), {
		useCORS: true,
	}).then(canvas => {
		let dataURL = canvas.toDataURL("image/png")
		if (dataURL !== "") {
			let a = document.createElement('a')
			a.download = formData.value.depotGrainName + '_预约码'
			a.href = dataURL
			a.click()
		}
	})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
